'' =================================================================================================
''
''   File....... led_ctrl_demo.spin
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2010 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.term
''   Started.... 
''   Updated.... 22 NOV 2010
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
' _xinfreq = 5_000_000                                          ' use 5MHz crystal
  _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1  = 31
  TX1  = 30
  SDA  = 29
  SCL  = 28

  LED1 = 16                                                     ' for demo board
  LED2 = 23


con

  IS_ON  = 1
  IS_OFF = 0


con 

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control


obj

  term : "fullduplexserial"
  led  : "led_ctrl"


pub main

  led.init                                                      ' setup leds object

  term.start(RX1, TX1, %0000, 115_200)                          ' setup terminal object
  pause(1)

  term.tx(CLS)
  term.str(string("LED Control Demo", CR, CR))

  dira[23..16] := $FF                                           ' for demo board only

  repeat
    repeat while led.busy                                       ' wait for availability
    term.str(string("LED #1 On", CR))
    led.set(LED1, IS_ON)
    repeat while led.busy                                       ' wait for availability
    term.str(string("Blink LED #2 5x", CR))
    led.blink(LED2, 5, 1000)                                    ' 5x, 1000ms per blink   
    repeat while led.busy                                       ' wait for availability
    term.str(string("LED #1 Off", CR))
    led.set(LED1, IS_OFF)
    repeat while led.busy                                       ' wait for availability
    term.str(string("Blink LED #2 10x", CR))
    led.blink(LED2, 10, 250)                                    ' 10x, 250ms per blink
      
 
pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)

                       
dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}